import PropTypes from "prop-types";
import React from "react";
import { PaginationOptions } from "react-bootstrap-table-nextgen";
import PaginationListStandalone from "./src/pagination-list-standalone";
import PaginationTotalStandalone from "./src/pagination-total-standalone";
import SizePerPageDropdownStandalone from "./src/size-per-page-dropdown-standalone";
export interface PaginationCtxOptions {
    options?: PaginationOptions | undefined;
}
export interface PaginationChildProps extends PaginationOptions {
    tableId?: string | undefined;
    bootstrap4?: boolean | undefined;
}
export interface PaginationProviderProps {
    pagination?: PaginationCtxOptions | undefined;
    children: any;
    tableId?: string | undefined;
    bootstrap4?: boolean | undefined;
    remoteEmitter: any;
    data: any[];
    isRemotePagination: Function;
}
export interface PaginationDataProviderProps {
    data: any[];
    remoteEmitter: Record<string, any>;
    isRemotePagination: () => boolean;
    children: React.ReactNode;
    pagination: {
        options: {
            custom?: boolean;
            pageStartIndex?: number;
            onPageChange: (newPage: any, currSizePerPage: number) => void;
        };
    };
    onDataSizeChange?: (dataSize: {
        dataSize: number;
    }) => void;
}
declare const _default: (options?: {}) => {
    createContext: () => {
        Provider: {
            new (props: import("./lib").PaginationProviderProps): {
                currPage: any;
                setRemoteEmitter: any;
                componentDidUpdate(nextProps: import("./lib").PaginationDataProviderProps): void;
                isRemotePagination: () => any;
                renderDefaultPagination: () => React.JSX.Element | null;
                render(): React.JSX.Element;
                currSizePerPage: any;
                dataChangeListener: any;
                dataSize: any;
                remoteEmitter: any;
                getPaginationProps: () => {
                    bootstrap4: boolean | undefined;
                    tableId: string | undefined;
                    page: any;
                    sizePerPage: any;
                    pageStartIndex: number;
                    hidePageListOnlyOnePage: boolean;
                    hideSizePerPage: boolean;
                    alwaysShowAllBtns: boolean;
                    withFirstAndLast: boolean;
                    dataSize: any;
                    sizePerPageList: number[] | {
                        text: string;
                        value: number;
                    }[];
                    paginationSize: number;
                    showTotal: boolean | undefined;
                    pageListRenderer: ((options: import("react-bootstrap-table-nextgen").PageListRendererOptions) => JSX.Element) | undefined;
                    pageButtonRenderer: ((options: import("react-bootstrap-table-nextgen").PageButtonRendererOptions) => JSX.Element) | undefined;
                    sizePerPageRenderer: ((options: import("react-bootstrap-table-nextgen").SizePerPageRendererOptions) => JSX.Element) | undefined;
                    paginationTotalRenderer: ((from: number, to: number, size: number) => JSX.Element) | undefined;
                    sizePerPageOptionRenderer: ((options: import("react-bootstrap-table-nextgen").SizePerPageOptionRendererOptions) => JSX.Element) | undefined;
                    firstPageText: string | JSX.Element;
                    prePageText: string | JSX.Element;
                    nextPageText: string | JSX.Element;
                    lastPageText: string | JSX.Element;
                    prePageTitle: string;
                    nextPageTitle: string;
                    firstPageTitle: string;
                    lastPageTitle: string;
                    onPageChange: (currPage: any) => void;
                    onSizePerPageChange: (currSizePerPage: any, currPage: any) => void;
                    custom?: boolean | undefined;
                    totalSize?: number | undefined;
                };
                setPaginationRemoteEmitter: (remoteEmitter: any) => void;
                getPaginationRemoteEmitter: () => any;
                handleDataSizeChange(newDataSize: any): void;
                handleChangePage(currPage: any): void;
                handleChangeSizePerPage(currSizePerPage: any, currPage: any): void;
                context: unknown;
                setState<K extends never>(state: {} | ((prevState: Readonly<{}>, props: Readonly<import("./lib").PaginationProviderProps>) => {} | Pick<{}, K> | null) | Pick<{}, K> | null, callback?: (() => void) | undefined): void;
                forceUpdate(callback?: (() => void) | undefined): void;
                readonly props: Readonly<import("./lib").PaginationProviderProps>;
                state: Readonly<{}>;
                refs: {
                    [key: string]: React.ReactInstance;
                };
                componentDidMount?(): void;
                shouldComponentUpdate?(nextProps: Readonly<import("./lib").PaginationProviderProps>, nextState: Readonly<{}>, nextContext: any): boolean;
                componentWillUnmount?(): void;
                componentDidCatch?(error: Error, errorInfo: React.ErrorInfo): void;
                getSnapshotBeforeUpdate?(prevProps: Readonly<import("./lib").PaginationProviderProps>, prevState: Readonly<{}>): any;
                componentWillMount?(): void;
                UNSAFE_componentWillMount?(): void;
                componentWillReceiveProps?(nextProps: Readonly<import("./lib").PaginationProviderProps>, nextContext: any): void;
                UNSAFE_componentWillReceiveProps?(nextProps: Readonly<import("./lib").PaginationProviderProps>, nextContext: any): void;
                componentWillUpdate?(nextProps: Readonly<import("./lib").PaginationProviderProps>, nextState: Readonly<{}>, nextContext: any): void;
                UNSAFE_componentWillUpdate?(nextProps: Readonly<import("./lib").PaginationProviderProps>, nextState: Readonly<{}>, nextContext: any): void;
            };
            propTypes: {
                data: PropTypes.Validator<any[]>;
                remoteEmitter: PropTypes.Validator<object>;
                isRemotePagination: PropTypes.Validator<(...args: any[]) => any>;
            };
            contextType?: React.Context<any> | undefined;
        };
        Consumer: React.Consumer<any>;
    };
    options: {};
};
export default _default;
export declare const PaginationProvider: {
    (props: PaginationProviderProps): React.JSX.Element;
    propTypes: {
        children: PropTypes.Validator<(...args: any[]) => any>;
    };
};
export { PaginationListStandalone, PaginationTotalStandalone, SizePerPageDropdownStandalone, };
