import PropTypes from "prop-types";
import React from "react";
import { PaginationDataProviderProps } from "..";
declare const Provider: {
    new (props: import("..").PaginationProviderProps): {
        currPage: any;
        currSizePerPage: any;
        dataChangeListener: any;
        dataSize: any;
        remoteEmitter: any;
        getPaginationProps: () => {
            bootstrap4: boolean | undefined;
            tableId: string | undefined;
            page: any;
            sizePerPage: any;
            pageStartIndex: number;
            hidePageListOnlyOnePage: boolean;
            hideSizePerPage: boolean;
            alwaysShowAllBtns: boolean;
            withFirstAndLast: boolean;
            dataSize: any;
            sizePerPageList: number[] | {
                text: string;
                value: number;
            }[];
            paginationSize: number;
            showTotal: boolean | undefined;
            pageListRenderer: ((options: import("react-bootstrap-table-nextgen").PageListRendererOptions) => JSX.Element) | undefined;
            pageButtonRenderer: ((options: import("react-bootstrap-table-nextgen").PageButtonRendererOptions) => JSX.Element) | undefined;
            sizePerPageRenderer: ((options: import("react-bootstrap-table-nextgen").SizePerPageRendererOptions) => JSX.Element) | undefined;
            paginationTotalRenderer: ((from: number, to: number, size: number) => JSX.Element) | undefined;
            sizePerPageOptionRenderer: ((options: import("react-bootstrap-table-nextgen").SizePerPageOptionRendererOptions) => JSX.Element) | undefined;
            firstPageText: string | JSX.Element;
            prePageText: string | JSX.Element;
            nextPageText: string | JSX.Element;
            lastPageText: string | JSX.Element;
            prePageTitle: string;
            nextPageTitle: string;
            firstPageTitle: string;
            lastPageTitle: string;
            onPageChange: (currPage: any) => void;
            onSizePerPageChange: (currSizePerPage: any, currPage: any) => void;
            custom?: boolean | undefined;
            totalSize?: number | undefined;
        };
        setPaginationRemoteEmitter: (remoteEmitter: any) => void;
        getPaginationRemoteEmitter: () => any;
        componentDidUpdate(nextProps: any): void;
        isRemotePagination: () => undefined;
        handleDataSizeChange(newDataSize: any): void;
        handleChangePage(currPage: any): void;
        handleChangeSizePerPage(currSizePerPage: any, currPage: any): void;
        render(): React.JSX.Element;
        context: unknown;
        setState<K extends never>(state: {} | ((prevState: Readonly<{}>, props: Readonly<import("..").PaginationProviderProps>) => {} | Pick<{}, K> | null) | Pick<{}, K> | null, callback?: (() => void) | undefined): void;
        forceUpdate(callback?: (() => void) | undefined): void;
        readonly props: Readonly<import("..").PaginationProviderProps>;
        state: Readonly<{}>;
        refs: {
            [key: string]: React.ReactInstance;
        };
        componentDidMount?(): void;
        shouldComponentUpdate?(nextProps: Readonly<import("..").PaginationProviderProps>, nextState: Readonly<{}>, nextContext: any): boolean;
        componentWillUnmount?(): void;
        componentDidCatch?(error: Error, errorInfo: React.ErrorInfo): void;
        getSnapshotBeforeUpdate?(prevProps: Readonly<import("..").PaginationProviderProps>, prevState: Readonly<{}>): any;
        componentWillMount?(): void;
        UNSAFE_componentWillMount?(): void;
        componentWillReceiveProps?(nextProps: Readonly<import("..").PaginationProviderProps>, nextContext: any): void;
        UNSAFE_componentWillReceiveProps?(nextProps: Readonly<import("..").PaginationProviderProps>, nextContext: any): void;
        componentWillUpdate?(nextProps: Readonly<import("..").PaginationProviderProps>, nextState: Readonly<{}>, nextContext: any): void;
        UNSAFE_componentWillUpdate?(nextProps: Readonly<import("..").PaginationProviderProps>, nextState: Readonly<{}>, nextContext: any): void;
    };
    contextType?: React.Context<any> | undefined;
};
declare class PaginationDataProvider extends Provider {
    static propTypes: {
        data: PropTypes.Validator<any[]>;
        remoteEmitter: PropTypes.Validator<object>;
        isRemotePagination: PropTypes.Validator<(...args: any[]) => any>;
    };
    currPage: any;
    setRemoteEmitter: any;
    componentDidUpdate(nextProps: PaginationDataProviderProps): void;
    isRemotePagination: () => any;
    renderDefaultPagination: () => React.JSX.Element | null;
    render(): React.JSX.Element;
}
declare const _default: () => {
    Provider: typeof PaginationDataProvider;
    Consumer: React.Consumer<any>;
};
export default _default;
