"use strict";

var __importDefault = void 0 && (void 0).__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};
Object.defineProperty(exports, "__esModule", {
  value: true
});
var classnames_1 = __importDefault(require("classnames"));
var prop_types_1 = __importDefault(require("prop-types"));
var react_1 = __importDefault(require("react"));
var size_per_page_option_1 = __importDefault(require("./size-per-page-option"));
var sizePerPageDefaultClass = "react-bs-table-sizePerPage-dropdown";
var SizePerPageDropDown = function SizePerPageDropDown(props) {
  var open = props.open,
    tableId = props.tableId,
    hidden = props.hidden,
    onClick = props.onClick,
    onBlur = props.onBlur,
    options = props.options,
    className = props.className,
    variation = props.variation,
    bootstrap4 = props.bootstrap4,
    btnContextual = props.btnContextual,
    optionRenderer = props.optionRenderer,
    currSizePerPage = props.currSizePerPage,
    onSizePerPageChange = props.onSizePerPageChange;
  var openClass = open ? "open show" : "";
  var dropdownClasses = (0, classnames_1["default"])(openClass, sizePerPageDefaultClass, variation, className);
  var id = tableId ? "".concat(tableId, "-pageDropDown") : "pageDropDown";
  return react_1["default"].createElement("span", {
    style: {
      visibility: hidden ? "hidden" : "visible"
    },
    className: dropdownClasses
  }, react_1["default"].createElement("button", {
    id: id,
    type: "button",
    className: "btn ".concat(btnContextual, " dropdown-toggle"),
    "data-toggle": "dropdown",
    "aria-expanded": open,
    onClick: onClick,
    onBlur: onBlur
  }, currSizePerPage, " ", bootstrap4 ? null : react_1["default"].createElement("span", null, react_1["default"].createElement("span", {
    className: "caret"
  }))), react_1["default"].createElement("ul", {
    className: "dropdown-menu ".concat(openClass),
    role: "menu",
    "aria-labelledby": id
  }, options.map(function (option) {
    if (optionRenderer) {
      return optionRenderer(Object.assign(Object.assign({}, option), {
        onSizePerPageChange: onSizePerPageChange
      }));
    }
    return react_1["default"].createElement(size_per_page_option_1["default"], Object.assign({}, option, {
      key: option.text,
      bootstrap4: bootstrap4,
      onSizePerPageChange: onSizePerPageChange
    }));
  })));
};
SizePerPageDropDown.propTypes = {
  currSizePerPage: prop_types_1["default"].string.isRequired,
  options: prop_types_1["default"].array.isRequired,
  onClick: prop_types_1["default"].func.isRequired,
  onBlur: prop_types_1["default"].func.isRequired,
  onSizePerPageChange: prop_types_1["default"].func.isRequired,
  bootstrap4: prop_types_1["default"].bool,
  tableId: prop_types_1["default"].string,
  open: prop_types_1["default"].bool,
  hidden: prop_types_1["default"].bool,
  btnContextual: prop_types_1["default"].string,
  variation: prop_types_1["default"].oneOf(["dropdown", "dropup"]),
  className: prop_types_1["default"].string,
  optionRenderer: prop_types_1["default"].func
};
SizePerPageDropDown.defaultProps = {
  open: false,
  hidden: false,
  btnContextual: "btn-default btn-secondary",
  variation: "dropdown",
  className: "",
  optionRenderer: null,
  bootstrap4: false,
  tableId: null
};
exports["default"] = SizePerPageDropDown;