"use strict";

var __importDefault = void 0 && (void 0).__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};
Object.defineProperty(exports, "__esModule", {
  value: true
});
var prop_types_1 = __importDefault(require("prop-types"));
var react_1 = __importDefault(require("react"));
var SizePerPageOption = function SizePerPageOption(_ref) {
  var text = _ref.text,
    page = _ref.page,
    onSizePerPageChange = _ref.onSizePerPageChange,
    bootstrap4 = _ref.bootstrap4;
  return bootstrap4 ? react_1["default"].createElement("a", {
    href: "#",
    tabIndex: -1,
    role: "menuitem",
    className: "dropdown-item",
    "data-page": page,
    onMouseDown: function onMouseDown(e) {
      e.preventDefault();
      onSizePerPageChange(page);
    }
  }, text) : react_1["default"].createElement("li", {
    key: text,
    role: "presentation",
    className: "dropdown-item"
  }, react_1["default"].createElement("a", {
    href: "#",
    tabIndex: -1,
    role: "menuitem",
    "data-page": page,
    onMouseDown: function onMouseDown(e) {
      e.preventDefault();
      onSizePerPageChange(page);
    }
  }, text));
};
SizePerPageOption.propTypes = {
  text: prop_types_1["default"].string.isRequired,
  page: prop_types_1["default"].number.isRequired,
  onSizePerPageChange: prop_types_1["default"].func.isRequired,
  bootstrap4: prop_types_1["default"].bool
};
SizePerPageOption.defaultProps = {
  bootstrap4: false
};
exports["default"] = SizePerPageOption;